VERSION 5.00
Begin VB.UserControl FileCopier 
   ClientHeight    =   525
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   660
   InvisibleAtRuntime=   -1  'True
   Picture         =   "FileCop.ctx":0000
   ScaleHeight     =   525
   ScaleWidth      =   660
   ToolboxBitmap   =   "FileCop.ctx":0262
End
Attribute VB_Name = "FileCopier"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Event Progress(ByVal total_bytes As Long, ByVal bytes_copied As Long)
Public Event CopyComplete(ByVal total_bytes As Long)

Private m_FromFile As String
Private m_ToFile As String

' Error codes.
Public Enum fcErrors
    fc_CopyInProgress = vbObjectError + 1001
    fc_NoCopyInProgress = vbObjectError + 1002
    fc_FileExists = vbObjectError + 1003
End Enum
' Copy from_file to to_file, raising the
' Progress event periodically.
Public Sub CopyFile(ByVal from_file As String, ByVal to_file As String)
    ' If a download is underway, complain.
    If Len(m_FromFile) > 0 Then
        Err.Raise fc_CopyInProgress, _
            "FileCopier.CopyFile", _
            "Copy already in progress"
    End If

    ' Do not copy if the file already exists.
    If Len(Dir$(to_file)) > 0 Then
        Err.Raise fc_FileExists, _
            "FileCopier.CopyFile", _
            "File already exists"
    End If

    ' Save the from and to file names.
    m_FromFile = from_file
    m_ToFile = to_file

    ' Start the download.
    AsyncRead from_file, vbAsyncTypeFile, _
        m_FromFile, vbAsyncReadForceUpdate
End Sub
' Cancel a file download if one is running.
Public Sub CancelCopy()
    ' If no download is underway, complain.
    If Len(m_FromFile) = 0 Then
        Err.Raise fc_NoCopyInProgress, _
            "FileCopier.CancelCopy", _
            "No copy in progress"
    End If

    ' Cancel the copy.
    CancelAsyncRead m_FromFile

    ' We are no longer copying.
    m_FromFile = ""
    m_ToFile = ""
End Sub
' Return True if a file download is in progress.
Property Get CopyInProgress() As Boolean
    CopyInProgress = (Len(m_FromFile) > 0)
End Property


' We are no longer copying.
Private Sub UserControl_AsyncReadComplete(AsyncProp As AsyncProperty)
    ' Move the temporary file into the output file.
    Name AsyncProp.Value As m_ToFile

    m_FromFile = ""
    m_ToFile = ""
    RaiseEvent CopyComplete(AsyncProp.BytesRead)
End Sub
' Give the program a status report.
Private Sub UserControl_AsyncReadProgress(AsyncProp As AsyncProperty)
    RaiseEvent Progress(AsyncProp.BytesMax, AsyncProp.BytesRead)
End Sub
Private Sub UserControl_Resize()
Const PIX_WID = 33
Const PIX_HGT = 24

    Width = Parent.ScaleX(PIX_WID, vbPixels, Parent.ScaleMode)
    Height = Parent.ScaleY(PIX_HGT, vbPixels, Parent.ScaleMode)
End Sub
